// SPDX-FileCopyrightText: 2022 Johannes Loher
//
// SPDX-License-Identifier: MIT

import type { DS4ActorDataPropertiesDataBase } from "../actor-data-properties-base";
import type {
  DS4CharacterDataSourceDataBaseInfo,
  DS4CharacterDataSourceDataCurrency,
  DS4CharacterDataSourceDataProfile,
  DS4CharacterDataSourceDataProgression,
  DS4CharacterDataSourceDataSlayerPoints,
} from "./character-data-source";

export interface DS4CharacterDataProperties {
  type: "character";
  data: DS4CharacterDataPropertiesData;
}

interface DS4CharacterDataPropertiesData extends DS4ActorDataPropertiesDataBase {
  baseInfo: DS4CharacterDataSourceDataBaseInfo;
  progression: DS4CharacterDataSourceDataProgression;
  profile: DS4CharacterDataSourceDataProfile;
  currency: DS4CharacterDataSourceDataCurrency;
  slayerPoints: DS4CharacterDataPropertiesDataSlayerPoints;
}

export interface DS4CharacterDataPropertiesDataSlayerPoints extends DS4CharacterDataSourceDataSlayerPoints {
  max: number;
}
