// SPDX-FileCopyrightText: 2022 Johannes Loher
//
// SPDX-License-Identifier: MIT

import type { DS4 } from "../../../config";
import type {
  DS4ItemDataSourceDataBase,
  DS4ItemDataSourceDataEquipable,
  DS4ItemDataSourceDataPhysical,
  DS4ItemDataSourceDataProtective,
} from "../item-data-source-base";

export interface DS4ArmorDataSource {
  type: "armor";
  data: DS4ArmorDataSourceData;
}

export interface DS4ArmorDataSourceData
  extends DS4ItemDataSourceDataBase,
    DS4ItemDataSourceDataPhysical,
    DS4ItemDataSourceDataEquipable,
    DS4ItemDataSourceDataProtective {
  armorMaterialType: keyof typeof DS4.i18n.armorMaterialTypes;
  armorType: keyof typeof DS4.i18n.armorTypes;
}
