// SPDX-FileCopyrightText: 2022 Johannes Loher
//
// SPDX-License-Identifier: MIT

import type { DS4AlphabetDataProperties } from "./alphabet/alphabet-data-properties";
import type { DS4ArmorDataProperties } from "./armor/armor-data-properties";
import type { DS4EquipmentDataProperties } from "./equipment/equipment-data-properties";
import type { DS4LanguageDataProperties } from "./language/language-data-properties";
import type { DS4LootDataProperties } from "./loot/loot-data-properties";
import type { DS4RacialAbilityDataProperties } from "./racial-ability/racial-ability-data-properties";
import type { DS4ShieldDataProperties } from "./shield/shield-data-properties";
import type { DS4SpecialCreatureAbilityDataProperties } from "./special-creature-ability/special-creature-ability-data-properties";
import type { DS4SpellDataProperties } from "./spell/spell-data-properties";
import type { DS4TalentDataProperties } from "./talent/talent-data-properties";
import type { DS4WeaponDataProperties } from "./weapon/weapon-data-properties";

declare global {
  interface DataConfig {
    Item: DS4ItemDataProperties;
  }
}

export type DS4ItemDataProperties =
  | DS4AlphabetDataProperties
  | DS4ArmorDataProperties
  | DS4EquipmentDataProperties
  | DS4LanguageDataProperties
  | DS4LootDataProperties
  | DS4RacialAbilityDataProperties
  | DS4ShieldDataProperties
  | DS4SpecialCreatureAbilityDataProperties
  | DS4SpellDataProperties
  | DS4TalentDataProperties
  | DS4WeaponDataProperties;
